.586p
.model flat, stdcall
option casemap :none

;******************************************************************************
;* INCLUDES                                                                   *
;******************************************************************************
include			\masm32\include\windows.inc
include			\masm32\include\user32.inc
include			\masm32\include\kernel32.inc
include			\masm32\include\shell32.inc
include			\masm32\include\advapi32.inc
include			\masm32\include\gdi32.inc
include			\masm32\include\comctl32.inc
include			\masm32\include\comdlg32.inc
include			\masm32\include\masm32.inc
include			\masm32\macros\macros.asm

includelib		\masm32\lib\user32.lib
includelib		\masm32\lib\kernel32.lib
includelib		\masm32\lib\shell32.lib
includelib		\masm32\lib\advapi32.lib
includelib		\masm32\lib\gdi32.lib
includelib		\masm32\lib\comctl32.lib
includelib		\masm32\lib\comdlg32.lib
includelib		\masm32\lib\masm32.lib

;******************************************************************************
;* PROTOTYPES                                                                 *
;******************************************************************************
DialogProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExtractCDKey		PROTO :HWND
Insert			PROTO :BYTE,:DWORD,:DWORD

;******************************************************************************
;* DATA & CONSTANTS                                                           *
;******************************************************************************
.const
IDD_MAIN	equ 	1
BTN_EXTRACT	equ 	101
IDC_CDKEY	equ 	102

.data
BaseTable	db	"BCDFGHJKMPQRTVWXY2346789",0
divisor 	dd	24d
dTable		dd	5,11,17,23
dwLen		dd	100h

.data?
ProductID	db	100h dup(?)
szCdkey		db	40h dup(?)
szPID		db	40h dup(?)
hKey		HKEY	?

;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code
main:
	invoke InitCommonControls
	invoke GetModuleHandle,0
        invoke DialogBoxParam,eax,1,0,addr DialogProc,0
        
        invoke ExitProcess,0

DialogProc proc uses ebx esi edi hwnd:dword,message:dword,wparam:dword,lparam:dword
	
	mov eax,message
		
	.if eax==WM_COMMAND

		mov eax,wparam

		.if ax==BTN_EXTRACT
			shr eax,16
			.if ax==BN_CLICKED
				invoke ExtractCDKey,hwnd
			.endif
		.endif
		
	.elseif eax==WM_CLOSE
	
		invoke EndDialog,hwnd,0
		
	.endif
	
	xor eax,eax
	ret 	                         
DialogProc endp


ExtractCDKey proc hwnd:HWND

	;**************************************************
	;* Read Digital Product ID from Registry
	;**************************************************

	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,chr$("SOFTWARE\Microsoft\Windows NT\CurrentVersion"), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, addr hKey
	cmp eax,ERROR_SUCCESS
	jnz _error
	invoke RegQueryValueEx,hKey, chr$("DigitalProductId"), 0, 0, addr ProductID, addr dwLen
	cmp eax,ERROR_SUCCESS
	jnz _error
	invoke RegCloseKey,hKey

	jmp _s
	_error:
	invoke RegCloseKey,hKey
	invoke SetDlgItemText,hwnd,IDC_CDKEY,chr$("Couldn't read data from registry.")
	xor eax,eax
	ret
	
	_s:
	xor ebx,ebx
	mov ecx,15
	_l:
	mov al, byte ptr[ProductID+ecx+66-15]
	mov byte ptr[szPID+ebx],al
	inc ebx
	loop _l

	;**************************************************
	;* Base24 Encode
	;**************************************************

	mov ecx,25
	_l1:
	push ecx
	mov edi,offset szPID
	mov ebx,24d
	mov ecx,15
	xor esi,esi
	_l2:
	movzx eax, byte ptr [edi]
	shl esi,8
	xor esi,eax
	mov eax,esi
	cdq
	div ebx
	mov byte ptr [edi],al
	mov esi,edx
	inc edi
	loop _l2
	pop ecx
	mov ebx,offset szCdkey
	mov al,byte ptr[BaseTable+esi]
	mov byte ptr[ebx+ecx-1],al
	loop _l1

	xor ecx,ecx
	_l3:
	mov eax, [dTable+ecx*4]
	invoke Insert,'-',addr szCdkey,eax
	inc ecx
	cmp ecx,4
	jb _l3

	invoke SetDlgItemText,hwnd,IDC_CDKEY,addr szCdkey
	invoke RtlZeroMemory,addr szCdkey, sizeof szCdkey

	xor eax,eax
	ret
ExtractCDKey endp

Insert proc uses ecx edi esi chr:BYTE,pStr:DWORD,pos:DWORD

	mov edi,pStr

	invoke lstrlen,edi
	add edi,eax
	sub eax,pos
	mov ecx,eax
	inc ecx

	mov esi,edi
	inc edi

	std
	rep movsb

	mov al,chr
	mov byte ptr[edi],al
	cld

	ret 3*4
Insert endp

end main

Coded by N1ghtm4r3
Thanks to Gunther/ARTeam for his nice source.